<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\Relatorios\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class DadosDeCompraController extends \Zeedhi\Framework\Controller\Report
{
    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;

    public function __construct($reportService, $entityManager, $birtStrategy, $newCode, $environment, $connection, $dataSourceManager)
    {
        $this->entityManager       = $entityManager;
        $this->birtStrategy        = $birtStrategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
        $this->dataSourceManager   = $dataSourceManager;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();

        $row['QR2TYPE'] = $row['QR2TYPE'] == 'XLS' ? 'XLSX' : $row['QR2TYPE'];
        
        $this->birtStrategy->setReportFormat($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array (
                        "NRORG"                 => "P_NRORG",
                        "CDOPERADOR"            => "P_CDOPERADOR",
                        "P_CDAREAGERE"          => "P_CDAREAGERE",
                        "P_CDGRUPFILI"          => "P_CDGRUPFILI",
                        "P_CDFILIAL"            => "P_CDFILIAL",
                        "CDTIPOCUSTO"           => "P_NRTIPOCUSTO",
                        "GRUPPROD"              => "P_CDGRUPPROD",
                        "INDICE"                => "P_INDICE",
                        "P_DATA_REF_INICIAL"    => "P_DATA_REF_INICIAL",
                        "P_DATA_REF_FINAL"      => "P_DATA_REF_FINAL",
                        "P_DATA_INICIAL"        => "P_DATA_INICIAL",
                        "P_DATA_FINAL"          => "P_DATA_FINAL"
                    ),
            );
    }
}
