<?php
namespace Teknisa\CMP\Modules\V1\Controllers; 

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp03800 extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $stNomeRel;

    public function __construct($reportService, $entityManager, $qr2Strategy) {
        
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;

    }

    protected $reportMapping = array ();
     public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
        
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                array (
                    'DATAINI' => 'P_DATAINI',
                    'DATAFIN' => 'P_DATAFIN',
                    'FILIPROC' => 'P_FILIPROC',
                    'NRNECECOMP' => 'P_NRNECECOMP',
                    'CDFILIAL' => 'P_CDFILIAL'
                ),
            );

    }
}