function Cmp05700JustificativaSolicitacaoController(ScreenService, templateManager, General, ZhFilterPreferences, Utilities, MessageService) {
    
    this.setFilterInitValues = function(widget) {
        const filterRow = {
            "INTERVALDT": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
        };
        
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    this.widgetOnEnterOnce = function(widget) {
        //widget.getField("CDFILSOLEXT").filterProperties.readOnly = (window.projectCorp) ?  false : true;
        const filialField = widget.getField("CDFILSOLEXT");
        
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            const filterRow = {
        	    INTERVALDT : {
        	        'formattedStart': moment().format('DD/MM/YYYY'),
        	        'formattedEnd': moment().format('DD/MM/YYYY'),
        	        'start': moment().format('DD/MM/YYYY'),
        	        'end': moment().format('DD/MM/YYYY')
        	    },
        	    CDFILSOLEXT: [ getLocalVar("CDFILIAL") ],
        	    NMFILIAL: [ getLocalVar("NMFILIAL") ],
        	    P_CDOPERADOR: [ getLocalVar("CDOPERADOR") ]
            };
            
            if(response.dataset.data.CDFILCENTCMP == response.dataset.data.CDFILIAL) {
                var NMFILCENTCMP = response.dataset.data.NMFILCENTCMP;
                var CDFILCENTCMP = response.dataset.data.CDFILCENTCMP;
                filterRow.CDFILSOLEXT = [ CDFILCENTCMP ];
                filterRow.NMFILIAL = [ NMFILCENTCMP ];
                filialField.readOnly = false;
                filialField.reload().then(function(success) {
                    let verificador = 0;
    	           success.dataset.unidadeSolicitacaoExtra.forEach(function(filial) {
    	               if(filial.CDFILSOLEXT == filterRow.CDFILSOLEXT[0]) {
    	                   verificador++;
    	               }
    	           });
    	           if(verificador == 0) {
    	               delete filterRow.CDFILSOLEXT;
    	               delete filterRow.NMFILIAL;
    	               filialField.reload();
    	           }
                });
            } else {
                filialField.readOnly = true;
                filialField.reload().then(function(success) {
    	           if(filialField.readOnly == true) {
    	               let verificador = 0;
    	               success.dataset.unidadeSolicitacaoExtra.forEach(function(filial) {
    	                   if(filial.CDFILSOLEXT == filterRow.CDFILSOLEXT[0]) {
    	                       verificador++;
    	                   }
    	               });
    	               if(verificador == 0) {
    	                   filialField.validations.required = true;
    	                   MessageService.showMessageByCode("FILIAL_SEM_REGIAO", null, { type: 'ERROR' });
    	                   delete filterRow.CDFILSOLEXT;
    	                   delete filterRow.NMFILIAL;
    	                   filialField.reload();
    	               } else {
    	                   delete filialField.validations.required;
    	                   filialField.reload();
    	               }
    	           }
    	       });
            }
	       
            Utilities.startFilter(widget, filterRow);
            //this.setFilterInitValues(widget);
        }, function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
        });
    };

    this.filtrar = function(args) {
        var filterRow = args.e.preference.FILTER_ROW;
        
        if(typeof(filterRow) === 'object') {
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DTOPERINI": filterRow.INTERVALDT.start,
                "P_DTOPERFIN": filterRow.INTERVALDT.end,
                "P_CDFILSOLEXT": Array.isArray(filterRow.CDFILSOLEXT) && filterRow.CDFILSOLEXT.length ? filterRow.CDFILSOLEXT.join('_') : 'T',
                "NRORG": filterRow.NRORG,
                "P_CDOPERADOR": getLocalVar("CDOPERADOR")
            };
        }
        
        /* Impede que, ao pesquisar por TODAS as Unidades (campo em branco), 
        o campo 'Unidade Solicitante' do corpo do relatório venha somente com a
        Unidade logada preenchida.
        */
        if (args.e.preference.CUSTOM_FILTER_ROW.P_CDFILSOLEXT === 'T') {
            args.owner.getField('CDFILSOLEXT').dataSource.reload();
        }
    };
    
    this.setStripe = function(widget) {
        var filterRow = widget.appliedFilter.FILTER_ROW;
        
        widget.container.getWidget("stripe").currentRow.DTOPERINI = filterRow.INTERVALDT.start + " a " + filterRow.INTERVALDT.end;
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp05700JustificativaSolicitacaoController', Cmp05700JustificativaSolicitacaoController);
});